//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,bmi2,fma")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;
//template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
//    freopen("robot.in", "r", stdin);
//    freopen("robot.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define ld long double
constexpr int MAXN = 3e5 + 1, MX = 1e5;
constexpr long long INF = 2e18;
constexpr int MOD = 1e9 + 7, P = 26;
const double pi = acos(-1);
const long double EPS = 1e-9;
const int K = 500;

vector<int> gr[MAXN];


void solve() {
    int n;
    cin >> n;
    int m, k;
    cin >> m >> k;
    for (int i =0 ; i <m;i++) {
        int a,b;
        cin >> a >> b;
        a--;b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    vector<int> dist(n, -INF);
    set<pair<int,int>> st;
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        p--;
        dist[p] = h;
        st.insert({h, p});
    }
    while (!st.empty()) {
        auto z = *--st.end();
        int v= z.second;
        st.erase(--st.end());
        if (dist[v] == 0) {
            continue;
        }
        for (int i : gr[v]) {
            if (dist[i] < dist[v]-1) {
                st.erase({dist[i], i});
                dist[i] = dist[v]-1;
                st.insert({dist[i], i});
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (dist[i] != -INF) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i + 1 << ' ';
    }
}