//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,bmi2,fma")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;
//template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
//    freopen("robot.in", "r", stdin);
//    freopen("robot.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define ld long double
constexpr int MAXN = 12, MX = 1e5;
constexpr long long INF = 2e18;
constexpr int MOD = 1e9 + 7, P = 26;
const ld pi = acosl(-1);
const long double EPS = 1e-9;
const int K = 500;

struct Point {
    ld x, y;

    Point() {}

    Point(ld x, ld y) : x(x), y(y) {}
    ld len() {
        return hypot(x,y);
    }
};

Point norm(Point a) {
    ld l = a.len();
    return {a.x/l, a.y/l};
}

Point operator-(Point a, Point b) {
    return {b.x - a.x, b.y - a.y};
}

long long operator*(Point &a, Point &b) {
    return a.x * b.x + a.y * b.y;
}

long long operator%(Point &a, Point &b) {
    return a.x * b.y - b.x * a.y;
}

istream& operator>>(istream& in, Point &a) {
    return in >> a.x >> a.y;
}

ostream& operator<<(ostream& out, Point &a) {
    return out << a.x << a.y;
}

vector<Point> a;
vector<Point> b;

Point rotate(Point x, ld ang) {
    return Point(x.x * cosl(ang) - x.y * sinl(ang), x.x * sinl(ang) + x.y * cosl(ang));
}

void pov(ld ang) {
    for (int i = 0; i < a.size(); i++) {
        b[i] = rotate(a[i], ang);
    }
}

auto timer = clock();


void solve() {
    int n;

    cout << fixed << setprecision(12);

    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i =0;i<n;i++) {
        cin >> a[i];
    }
    vector<int>p(n);
    iota(p.begin(), p.end(),0);
    ld mn = INF;
    while (true) {
        ld ans = INF;
        ld l = -EPS;
        ld r = 2 * pi+EPS;

        while (r - l > EPS) {
            ld m1 = l + (r-l)/3;
            ld m2 = r - (r-l)/3;
            pov(m1);
            ld a1 = 0;
            for (int i = 0; i < n-1; i++) {
                a1 += abs(b[p[i]].x-b[p[i+1]].x) + abs(b[p[i]].y-b[p[i+1]].y);
            }
            pov(m2);
            ld a2 = 0;
            for (int i = 0; i < n-1; i++) {
                a2 += abs(b[p[i]].x-b[p[i+1]].x) + abs(b[p[i]].y-b[p[i+1]].y);
            }
            ans = min({ans, a1,a2});
            if (a2 <= a1) {
                l = m1;
            } else {
                r = m2;
            }
        }
        if (ans < mn) {
            mn = ans;
        }
        if (!next_permutation(p.begin(), p.end())){
            break;
        }
    }
    while (true) {
        ld ans = INF;
        ld l = -2*pi-EPS;
        ld r = EPS;

        while (r - l > EPS) {
            ld m1 = l + (r-l)/3;
            ld m2 = r - (r-l)/3;
            pov(m1);
            ld a1 = 0;
            for (int i = 0; i < n-1; i++) {
                a1 += abs(b[p[i]].x-b[p[i+1]].x) + abs(b[p[i]].y-b[p[i+1]].y);
            }
            pov(m2);
            ld a2 = 0;
            for (int i = 0; i < n-1; i++) {
                a2 += abs(b[p[i]].x-b[p[i+1]].x) + abs(b[p[i]].y-b[p[i+1]].y);
            }
            ans = min({ans, a1,a2});
            if (a2 <= a1) {
                l = m1;
            } else {
                r = m2;
            }
        }
        if (ans < mn) {
            mn = ans;
        }
        if (!next_permutation(p.begin(), p.end())){
            break;
        }
    }
    cout << mn;
}