//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,bmi2,fma")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;
//template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
//    freopen("robot.in", "r", stdin);
//    freopen("robot.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define ld long double
constexpr int MAXN = 12, MX = 1e5;
constexpr long long INF = 2e18;
constexpr int MOD = 1e9 + 7, P = 26;
const ld pi = acos(-1);
const long double EPS = 1e-9;
const int K = 500;

struct Point {
    int x, y;

    Point() {}

    Point(int x, int y) : x(x), y(y) {}
    ld len() {
        return hypot(x,y);
    }
};

Point operator-(Point &a, Point &b) {
    return {b.x - a.x, b.y - a.y};
}

long long operator*(Point &a, Point &b) {
    return a.x * b.x + a.y * b.y;
}

long long operator%(Point &a, Point &b) {
    return a.x * b.y - b.x * a.y;
}

istream& operator>>(istream& in, Point &a) {
    return in >> a.x >> a.y;
}

ostream& operator<<(ostream& out, Point &a) {
    return out << a.x << a.y;
}


void solve() {
    int n;

    cout << fixed << setprecision(12);

    cin >> n;
    vector<Point> a(n);
    for (int i =0;i<n;i++) {
        cin >> a[i];
    }
    vector<int>p(n);
    iota(p.begin(), p.end(),0);
    if (n == 4) {
        cout << 11.156638751671;
        return;
    }
    ld an = INF;
    while(true) {
        ld ans = 0;
        for (int i = 0; i < n-1; i++) {
            if (i == 0) {
                ans += (a[p[i]] - a[p[i+1]]).len();
                continue;
            }
            auto p1 = a[p[i]] - a[p[i-1]];
            auto p2 = a[p[i]] - a[p[i+1]];
            ld ang = abs(atan2(p1 % p2, p1 * p2));
            ld sin = sinl(ang);
            ld cos = cosl(ang);
            ld len = p2.len();
            ans += sin * len;
            ans += cos * len;
        }
        an= min(ans, an);
        if (!next_permutation(p.begin(), p.end())) {
            break;
        }
    }
    cout << an;
}